=== debian/control ===
Source: vulkan-memory-allocator
Section: x11
Priority: optional
Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake (>= 3.9),
 doxygen,
 libvulkan-dev
Standards-Version: 4.6.2
Homepage: https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator
Vcs-Browser: https://salsa.debian.org/debian/vulkan-memory-allocator
Vcs-Git: https://salsa.debian.org/debian/vulkan-memory-allocator.git

Package: libvulkan-memory-allocator-dev
Architecture: any
Section: libdevel
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: vulkan memory allocation library (development package)
 Easy to integrate Vulkan memory allocation library.
 .
 This package contains the development headers.

Package: vulkan-memory-allocator-doc
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: vulkan memory allocation library (documentation)
 Easy to integrate Vulkan memory allocation library.
 .
 This package contains the documentation.
