## vulkan-memory-allocator 3.0.1+git20230911+2f382df+dfsg

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: vulkan-memory-allocator
 Section: x11
 Priority: optional
-Maintainer: Matthias Geiger <matthias.geiger1024@tutanota.de>
+Maintainer: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- cmake (>= 3.9),
+ cmake (>= 3.15),
  doxygen,
  libvulkan-dev
 Standards-Version: 4.6.2
@@ -14,7 +14,8 @@
 Vcs-Git: https://salsa.debian.org/debian/vulkan-memory-allocator.git
 
 Package: libvulkan-memory-allocator-dev
-Architecture: any
+Architecture: all
+Multi-Arch: foreign
 Section: libdevel
 Depends:
  ${shlibs:Depends},
@@ -26,6 +27,8 @@
 
 Package: vulkan-memory-allocator-doc
 Architecture: all
+Multi-Arch: foreign
+Section: doc
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
@@ -33,4 +36,3 @@
  Easy to integrate Vulkan memory allocation library.
  .
  This package contains the documentation.
-
