=== debian/watch ===
version=4
opts=\
mode=git,\
pretty=3.0.1+git%cd+%h,\
repacksuffix=+dfsg,\
repack,compression=gz,\
dversionmangle=s/\+(dfsg)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/vulkan-memory-allocator-$1\.tar\.gz/ \
  https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator.git HEAD
