## vulkan-memory-allocator 3.1.0+dfsg

=== debian/changelog ===
vulkan-memory-allocator (3.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Updated gbp.conf for switch to regular releases
  * Updated d/watch to track tags instead of snapshots

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 31 May 2024 13:29:30 +0200
