## vulkan-memory-allocator 3.2.0+dfsg

=== debian/changelog ===
vulkan-memory-allocator (3.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update my mail address
  * d/control: Bump S-V to 4.7.0; no changes needed
  * d/u/metadata: Update for new upstream url
  * Install VulkanMemoryAllocatorConfigVersion.cmake, too

 -- Matthias Geiger <werdahias@debian.org>  Fri, 03 Jan 2025 19:14:31 +0100
