## vulkan-memory-allocator 3.2.1+dfsg

=== debian/changelog ===
vulkan-memory-allocator (3.2.1+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@debian.org>  Sun, 09 Feb 2025 17:13:27 +0100
