=== debian/changelog ===
vulkan-memory-allocator (3.3.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release

 -- Antoine Lassagne <antoine.lassagne@canonical.com>  Fri, 17 Oct 2025 09:25:24 +0200
