=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: vulkan-memory-allocator
 Section: x11
 Priority: optional
-Maintainer: Matthias Geiger <werdahias@riseup.net>
+Maintainer: Matthias Geiger <werdahias@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  cmake (>= 3.15),
  doxygen,
  libvulkan-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator
 Vcs-Browser: https://salsa.debian.org/debian/vulkan-memory-allocator
 Vcs-Git: https://salsa.debian.org/debian/vulkan-memory-allocator.git
