=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=gz,\
dversionmangle=s/\+(dfsg)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/vulkan-memory-allocator-$1\.tar\.gz/ \
  https://github.com/GPUOpen-LibrariesAndSDKs/VulkanMemoryAllocator/tags .*/v?(\d\S*)\.tar\.gz
